///////////////////////////////////////////////////////////////////////////////////
// A4 main wdl
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "models";	// Path to model subdirectory - if any
path "sounds";	// Path to sound subdirectory - if any
path "bmaps";		// Path to graphics subdirectory - if any
path "C:\\ARCHIVOS DE PROGRAMA\\GSTUDIO\\template";	// Path to WDL templates subdirectory

////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated actions
include <movement.wdl>;
include <actors.wdl>;   // remove when you need no actors
////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode = 6;	 // screen size 640x480
var video_depth = 32; // 16 bit colour D3D mode

SOUND bote,<rebote.wav>;

DEFINE _altu_pelo,SKILL36;
DEFINE _fuerza_pelo,SKILL38;

DEFINE __PARAMITAM,FLAG1;// 
DEFINE __PARAMI,FLAG2;	// 
DEFINE __CAIDO,FLAG7;	// 
DEFINE __JUGA_SELEC, FLAG8;	// es el palyer activo

BMAP sky1,<cielo.bmp>;
BMAP sky2,<nube.bmp>;



var dist[3];
var angle[3];

SYNONYM pelota { TYPE ENTITY; }
/////////////////////////////////////////////////////////////////
// The main() function is started at game start
function main()
{
	load_level(<blow.WMB>);

	SET SKY_MAP,sky1;
	SET CLOUD_MAP,sky2;

	SKY_SPEED.X = 0.6;
	SKY_SPEED.Y = 1;
	CLOUD_SPEED.X = 2;
	CLOUD_SPEED.Y = 3;
	SKY_SCALE = 5;
	SKY_CURVE = 3;
}


/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

action Ajugador{ //cambiar de jujador
IF (MY.__JUGA_SELEC == ON){
CAMERA.tilt = -20;
player_move();}
ELSE{
actor_follow();} //pop ahora despues mandarta las acciones la ia
}


////////////////////////////////////////////////////////////////
///PELOTA//////////////////////////////////////////////////////
function rebote_jugador
{
IF (event_type == event_impact){ //cuando lo golpea un keko
//MY.TILT = 0; 
rebote();
}
IF (event_type == event_Block){ //para rebotar en las paredes
//MY._fuerza_pelo = 0;
//MY._altu_pelo = 0;
TO_ANGLE angle,BOUNCE; // bounce off the surface
MY.PAN = (my.pan + random (2*120) -120); //
//MY.TILT = 0; 
//MY._fuerza_pelo = (random (8));
//MY._altu_pelo = (random (8));
PLAY_SOUND bote, 30;
} 

IF (event_type == event_entity){ //mientras esta en la function rebote y da a un keko.
TO_ANGLE angle,BOUNCE; // bounce off the surface
MY.PAN = (my.pan + random (2*120) -120); //
//MY.TILT = 0; 
MY._fuerza_pelo = (random (8));

} 

} //final function rebote_jugador

action Apelota  
{
pelota = MY;
MY.FRAME = 1;
anim_pelo();
MY.__JUMP = ON;
MY.ENABLE_block = on;
MY.ENABLE_impact = ON;
MY.ENABLE_entity = ON;

MY.EVENT = rebote_jugador;
}    //final function apelota

function rebote()
{
MY._MOVEMODE = _MODE_JUMPING;
anim_pelo();
MY.ENABLE_impact = OFF;
PLAY_SOUND bote, 35;
MY._fuerza_pelo = 0;
MY._altu_pelo = 0;
IF (YOUR._SPEED_X < 0){ YOUR._SPEED_X = 8;} 
MY._fuerza_pelo = YOUR._SPEED_X;
MY._altu_pelo = (MY._fuerza_pelo + (random (2*4)+1));
IF (YOUR._SPEED_X < 0){ //
(MY.pan + random (2*65) -65);} //
ELSE{MY.PAN = (YOU.pan + random (2*65) -65);}
	while (my._fuerza_pelo > 1){
 	   	force.X = MY._fuerza_pelo;
		force.Y = 0;
		force.Z = MY._altu_pelo; //MY._fuerza_pelo;
		MY._SPEED_Z = sqrt((MY._altu_pelo)*2*gravity);
		scan_floor();
		move_gravity();
	  	my._fuerza_pelo -= 1;//resta velocidad
        wait(1);} // fin while
	while (MY.Z  > 4){
	scan_floor();
	move_gravity();
	wait (1);}
rebote1();
}

function rebote1(parriba)
{
MY.ENABLE_impact = OFF;
PLAY_SOUND bote, 35;
MY._fuerza_pelo = 0;
MY._altu_pelo = 0;
MY._fuerza_pelo = random (8)+ 8;
MY._altu_pelo = (MY._fuerza_pelo + (random (2*4)));
my.pan = random (180);
parriba = random (5);
IF (PARRIBA < 1){MY.TILT = 90;}
	while (my._fuerza_pelo > 1){
 	   	force.X = MY._fuerza_pelo;
		force.Y = 0;
		force.Z = MY._altu_pelo; //MY._fuerza_pelo;
		MY._SPEED_Z = sqrt((MY._altu_pelo)*2*gravity);
		scan_floor();
		move_gravity();
	  	my._fuerza_pelo -= 1;//resta velocidad
        wait(1);} // fin while
	while (MY.Z  > 4){
	scan_floor();
	move_gravity();
	wait (1);}
MY.TILT = 0;
PLAY_SOUND bote, 35;
MY._fuerza_pelo = 0;
MY._altu_pelo = 0;
MY._fuerza_pelo = random (6)+ 6;
MY._altu_pelo = (MY._fuerza_pelo + (random (2*3)));
my.pan = random (360);
parriba = random (5);
IF (PARRIBA < 1){MY.TILT = 90;}
	while (my._fuerza_pelo > 1){
 	   	force.X = MY._fuerza_pelo;
		force.Y = 0;
		force.Z = MY._altu_pelo;
		MY._SPEED_Z = sqrt((MY._altu_pelo)*2*gravity);
		scan_floor();
		move_gravity();
	  	my._fuerza_pelo -= 1;//resta velocidad
        wait(1);} // fin while
	while (MY.Z  > 4){
	scan_floor();
	move_gravity();
	wait (1);}
MY.TILT = 0;
PLAY_SOUND bote, 35;
MY._fuerza_pelo = 0;
MY._altu_pelo = 0;
MY._fuerza_pelo = random (4)+ 4;
MY._altu_pelo = (MY._fuerza_pelo + (random (2*2)));
my.pan = random (360);
	while (my._fuerza_pelo > 1){
	   	force.X = MY._fuerza_pelo;
		force.Y = 0;
		force.Z = MY._altu_pelo;
		MY._SPEED_Z = sqrt((MY._altu_pelo)*2*gravity);
		scan_floor();
		move_gravity();
	  	my._fuerza_pelo -= 1;//resta velocidad
        wait(1);} // fin while
	while (MY.Z  > 4){
	scan_floor();
	move_gravity();
	wait (1);}
MY.TILT = 0;
PLAY_SOUND bote, 35;
MY._fuerza_pelo = 0;
MY._altu_pelo = 0;
MY.TILT = 0; 
MY._fuerza_pelo = random (2)+ 2;
MY._altu_pelo = (MY._fuerza_pelo + (random (2)));
my.pan = random (360);
parriba = random (5);
IF (PARRIBA < 0){MY.TILT = 90;}
	while (my._fuerza_pelo > 1){
 	   	force.X = MY._fuerza_pelo;
		force.Y = 0;
		force.Z = MY._altu_pelo;
		MY._SPEED_Z = sqrt((MY._altu_pelo)*2*gravity);
		scan_floor();
		move_gravity();
	  	my._fuerza_pelo -= 1;//resta velocidad
        wait(1);} // fin while
	while (MY.Z  > 4){
	scan_floor();
	move_gravity();
	wait (1);}
MY.TILT = 0;
PLAY_SOUND bote, 35;
MY._fuerza_pelo = 0;
MY._altu_pelo = 0;
MY._fuerza_pelo = random (2)+ 2;
MY._altu_pelo = (MY._fuerza_pelo + (random (2)));
my.pan = random (360);
parriba = random (5);
IF (PARRIBA < 0){MY.TILT = 90;}
	while (my._fuerza_pelo > 1){
	   	force.X = MY._fuerza_pelo;
		force.Y = 0;
		force.Z = MY._altu_pelo;
		MY._SPEED_Z = sqrt((MY._altu_pelo)*2*gravity);
		scan_floor();
		move_gravity();
	  	my._fuerza_pelo -= 1;//resta velocidad
        wait(1);} // fin while
	while (MY.Z  > 4){
	scan_floor();
	move_gravity();
	wait (1);}
MY.TILT = 0;
PLAY_SOUND bote, 35;
MY._fuerza_pelo = 0;
MY._altu_pelo = 0;
MY.ENABLE_impact = ON;

MY.FRAME = 8;
MY._MOVEMODE = _MODE_WALKING;
} //final rebote1

action anim_pelo 
{
	while (MY._MOVEMODE == _MODE_JUMPING){
	MY.FRAME += 1.5*TIME;
		IF (MY.FRAME > 8){
		MY.FRAME = 0;}
	wait (1);}
	while (MY._MOVEMODE == _MODE_WALKING){
	MY.FRAME += 1.5*TIME;
		IF (MY.FRAME > 18){
		break;}
	wait (1);}

MY.FRAME = 1;
}    //final anim_pelo

////FIN DE PELOTA//////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

var force_x = 1;
function _player_intentions()
{
	if (key_V !=0)||(joy_2 !=0){ //movimento lateral (stafe)
		force.x = (strength.X*(KEY_FORCE.Y+JOY_FORCE.Y)/5);
		force.Y = (strength.Y*(KEY_FORCE.X+JOY_FORCE.X)*-1); 
		aforce.PAN = 0;
	}
else{correr();}
//}


IF (key_b !=0)||(joy_3 !=0){ //pase largo selo se muevc ela camara
pase_largo();
}
else{
while (CAMERA.tilt > -20) { 
	CAMERA.tilt -= 0.3;
	wait (1);}

}

// Limit the forces in case the player
// pressed buttons, mouse and joystick simultaneously
	limit.PAN = 2*astrength.PAN;
	limit.TILT = 2*astrength.TILT;
	limit.ROLL = 2*astrength.ROLL;

	IF (aforce.PAN > limit.PAN) {  aforce.PAN = limit.PAN; }
	IF (aforce.PAN < -limit.PAN) {  aforce.PAN = -limit.PAN; }
	IF (aforce.TILT > limit.TILT) {  aforce.TILT = limit.TILT; }
	IF (aforce.TILT < -limit.TILT) {  aforce.TILT = -limit.TILT; }
	IF (aforce.ROLL > limit.ROLL) {  aforce.ROLL = limit.ROLL; }
	IF (aforce.ROLL < -limit.ROLL) {  aforce.ROLL = -limit.ROLL; }

// Limit the forces in case the player tried to cheat by
// operating buttons, mouse and joystick simultaneously
	limit.X = 2*strength.X;
	limit.Y = 2*strength.Y;
	limit.Z = 2*strength.Z;

	IF (force.X > limit.X) {  force.X = limit.X; }
	IF (force.X < -limit.X) { force.X = -limit.X; }
	IF (force.Y > limit.Y) {  force.Y = limit.Y; }
	IF (force.Y < -limit.Y) { force.Y = -limit.Y; }
	IF (force.Z > limit.Z) {  force.Z = limit.Z; }
	IF (force.Z < -limit.Z) { force.Z = -limit.Z; }
}

}


function correr
{
	force.X = strength.X*(KEY_FORCE.Y+JOY_FORCE.Y); ///movimiento normal
	aforce.PAN = -astrength.PAN*(KEY_FORCE.X+JOY_FORCE.X);
}

function pase_largo (cabeza)
{
	force.X = 0;
	force.Y = 0;

	IF (KEY_FORCE.Y+JOY_FORCE.Y < 0) && (CAMERA.tilt < 35){ 
	CAMERA.tilt += 1;
	aforce.PAN += -astrength.PAN*(KEY_FORCE.X+JOY_FORCE.X);
	wait (1);}

	IF (KEY_FORCE.Y+JOY_FORCE.Y > 0) && (CAMERA.tilt > -20){ 
	CAMERA.tilt -= 1;
	aforce.PAN += -astrength.PAN*(KEY_FORCE.X+JOY_FORCE.X);
	wait (1);}
}



///TECLAS//////////////////////////////////////////////////////////////////

on_m main();

on_t AJUGADOR();

///////////////////////////////////////////////////////////////////////////
///FIN DE TECLAS///////////////////////////////////////////////////////////
